<template>
  <div>
    <div class="card">
      <nav class="navbar has-background-white-bis">
        <div class="navbar-brand">
          <span class="navbar-item title is-2">Listado de videos</span>
        </div>
        <div class="navbar-menu">
          <div class="navbar-end">
            <div class="navbar-item">
              <a class="button regular is-purple is-medium" @click="add">
                <span>Agregar</span>
                <span><i class="fa fa-plus" style=" margin-left: 9px;"></i></span>
              </a>
            </div>
          </div>
        </div>
      </nav>
      <div class="section">
          <b-table :loading="isLoading" :data="data">
             
             <b-table-column field="liveUrl" label="Video" width="40"  sortable  v-slot="props">
                 <iframe width="200" height="150" :src="'https://www.youtube.com/embed/'+extractVideoId(props.row.liveUrl)" frameborder="0" allowfullscreen></iframe>
            </b-table-column>
              <b-table-column  label="Acciones" width="40"   v-slot="props">
               <div class="buttons is-centered" style="
    margin-left: -74px;
">
              <b-tooltip
                type="is-warning"
                label="Editar"
              >
                <b-button
                  outlined
                  @click="edit(props.row.id)"
                  type="advise"
                  ><b-icon icon="pencil"></b-icon
                ></b-button>
              </b-tooltip>
              <b-tooltip
                type="is-danger"
                label="Eliminar"
              >
                <b-button
                  outlined
                  @click="remove(props.row.id)"
                  type="alert"
                  ><b-icon icon="delete"></b-icon
                ></b-button>
              </b-tooltip>
            </div>
            </b-table-column>
                <template #empty>
                <div class="has-text-centered title is-4">😢 No hay registro</div>
            </template>
          </b-table>
      </div>
    </div>
  </div>
</template>
<script lang='ts'>
import StreamVideoService from "@/services/streamVideoService";
import { Component, Vue, Watch } from "vue-property-decorator";

@Component
export default class StreamVideoTableComponent extends Vue {

  data:Array<StreamVideoService> = [];
  isLoading:boolean = false;
  streamVideoService:StreamVideoService = new StreamVideoService();
  created() {
    console.log("Hola desde created")
        this.getStreansVideo();
  }



 extractVideoId(url: string): string | null {
    // Regular expression to match the video ID in the YouTube URL
    const regExp = /(?:https?:\/\/)?(?:www\.)?(?:youtube\.com\/(?:[^\/\n\s]+\/\S+\/|(?:v|e(?:mbed)?)\/|\S*?[?&]v=)|youtu\.be\/)([a-zA-Z0-9_-]{11})/;
    
    // Execute the regular expression and extract the video ID
    const match = url.match(regExp);
    
    // Return the extracted video ID or null if not found
    return match ? match[1] : null;
}

    public add() {
        this.$router.push(`${this.$router.currentRoute.path}/agregar`)
    }

    public edit(id: number) {
        this.$router.push(`${this.$router.currentRoute.path}/editar/${id}`)
    }

    public remove(id: number) {
        this.$buefy.dialog.confirm({
            title: 'Confirmación',
            message: '¿Desea eliminar este registro?',
            confirmText: 'Adelante!',
            cancelText: 'Cancelar',
            type: 'is-danger',
            size: 'is-medium',
            hasIcon: true,
            onConfirm: () => this.confirmRemove(id)
        })
    }

     protected async confirmRemove(id: number) {
           this.streamVideoService.deleteStreamVideo(id).then(resp =>{
               this.getStreansVideo();
           })

    }

  getStreansVideo(){
      this.isLoading = true;
     this.streamVideoService.getStreamVideo().then(resp =>{
         this.data = resp.data;
     }).finally(()=>{
         this.isLoading = false;
     })
  }

 
 
}
</script>


